# Peertube

> https://joinpeertube.org/

An ActivityPub-federated video streaming platform using P2P directly in your web browser.

<!-- metadata -->

* **Category**: Apps
* **Status**: 2, beta
* **Image**: [`chocobozzz/peertube`](https://hub.docker.com/r/chocobozzz/peertube), 4, upstream
* **Healthcheck**: 3
* **Backups**: 1
* **Email**: 3
* **Tests**: No
* **SSO**: 1
<!-- endmetadata -->

## Basic usage

1. Set up Docker Swarm and [`abra`]
2. Deploy [`coop-cloud/traefik`]
3. `abra app new peertube --secrets` (optionally with `--pass` if you'd like
   to save secrets in `pass`)
4. `abra app YOURAPPDOMAIN config` - be sure to change `DOMAIN` to something that resolves to
   your Docker swarm box
5. `abra app YOURAPPDOMAIN deploy`
6. Open the configured domain in your browser to finish set-up

## Host-mode networking

To avoid issues with performance, it is recommended to deploy your Traefik instance with:

```
COMPOSE_FILE="compose.yml:compose.host.yml:compose.peertube.yml"
```

This will avoid issues like [`#7`](https://git.coopcloud.tech/coop-cloud/peertube/issues/7).

## Email

1. Deploy [`coop-cloud/postfix-relay`] or use an external SMTP relay
2. `abra app YOURAPPDOMAIN config`, and uncomment the email lines and adjust as needed
3. `abra app YOURAPPDOMAIN deploy`

[`abra`]: https://git.autonomic.zone/autonomic-cooperative/abra
[`coop-cloud/traefik`]: https://git.autonomic.zone/coop-cloud/traefik
[`coop-cloud/postfix-relay`]: https://git.autonomic.zone/coop-cloud/postfix-relay

## Plugins

- [`peertube-plugin-auth-openid-connect`](https://www.npmjs.com/package/peertube-plugin-auth-openid-connect) is the trusted OAuth2 support plugin (Keycloak integrations works!)

## Acknowledgements

Thanks to [@mirsal](https://git.coopcloud.tech/mirsal) for the packaging work :heart:
